#version 450 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

out vec3 FragPos;
out vec3 Normal;
out vec2 TexCoords;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;


void main()
{
    FragPos = vec3(modelMatrix * vec4(position, 1.0));
    Normal = mat3(transpose(inverse(modelMatrix)))  * aNormal;  
	TexCoords = aTexCoords;
    
    gl_Position = viewProjMatrix * vec4(FragPos, 1.0);
}