#version 450

in vec2 TexCoord0;
flat in float TTL0;
out vec4 FragColor;

uniform sampler2DArray diffuse;
uniform vec3 col;
uniform bool fire;

void main() {
	
	int textureNumber = int(clamp(TTL0, 0.0, 10.0)/2);
	int nextTexture = textureNumber - 1;
	float TTL_Value = abs(int(clamp(TTL0, 0.0, 10.0)/2) - clamp(TTL0, 0.0, 12.0)/2);
	float TTL_Value_next = 1.0 - TTL_Value;
	
	vec4 color = texture(diffuse, vec3(TexCoord0, textureNumber)).rgba * TTL_Value;
	if(nextTexture >= 0) {
		color = color + texture(diffuse, vec3(TexCoord0, nextTexture)).rgba * TTL_Value_next;
	}
	if(fire){
		vec3 col1 = vec3(0.0f,0.0f,0.0f);
		if(TTL0 < 3.0){
			col1 = vec3(col.x,1-clamp(TTL0,0.0,10.0)/10.0,1-clamp(TTL0,0.0,10.0)/10.0);
		} else {
			col1 = vec3(col.x,1-clamp(TTL0,0.0,10.0)/7.0,0.0);
		}
		
		FragColor = color * vec4(col1,1.0f * clamp(TTL0, 0.0, 10.0)/10.0);
	} else {
		FragColor = color * vec4(col,1.0f * clamp(TTL0, 0.0, 10.0)/10.0);
	}
	
	
	//}

	
}