#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

layout (location = 5) in ivec4 BoneIDs;
layout (location = 6) in vec4 Weights;

const int MAX_BONES = 100;

uniform mat4 modelMatrix;
uniform mat4 lightSpaceMatrix;
uniform mat4 gBones[MAX_BONES];

void main()
{
	mat4 BoneTransform 	= gBones[BoneIDs[0]] * Weights[0];
	BoneTransform		+= gBones[BoneIDs[1]] * Weights[1];
	BoneTransform		+= gBones[BoneIDs[2]] * Weights[2];
	BoneTransform		+= gBones[BoneIDs[3]] * Weights[3];
	gl_Position = lightSpaceMatrix * modelMatrix * BoneTransform * vec4(position, 1.0);
}