#version 450 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

layout (location = 5) in ivec4 BoneIDs;
layout (location = 6) in vec4 Weights;

out vec3 FragPos;
out vec3 Normal;
out vec2 TexCoords;
flat out ivec4 BoneIDs0;
out vec4 Weights0;

const int MAX_BONES = 100;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat4 gBones[MAX_BONES];

void main()
{
	mat4 BoneTransform 	= gBones[BoneIDs[0]] * Weights[0];
	BoneTransform		+= gBones[BoneIDs[1]] * Weights[1];
	BoneTransform		+= gBones[BoneIDs[2]] * Weights[2];
	BoneTransform		+= gBones[BoneIDs[3]] * Weights[3];
	
	
	

	FragPos = vec3(modelMatrix * vec4(position, 1.0));
	//FragPos = vec3(BoneTransform * vec4(position, 1.0));
	//FragPos = vec3(modelMatrix * BoneTransform * vec4(position, 1.0));
    gl_Position = viewProjMatrix * modelMatrix * BoneTransform * vec4(position, 1.0);
	//gl_Position = viewProjMatrix * modelMatrix * vec4(position, 1.0);
	TexCoords = aTexCoords;
	//Normal = aNormal;
	Normal = mat3(transpose(inverse(modelMatrix * BoneTransform)))  * aNormal;
	//FragPos = position;
	BoneIDs0 = BoneIDs;
	Weights0 = Weights;
}